org.apache.commons.math3.distribution

## Class TriangularDistribution

- java.lang.Object
- - org.apache.commons.math3.distribution.AbstractRealDistribution
  - - org.apache.commons.math3.distribution.TriangularDistribution

- All Implemented Interfaces:
    Serializable, RealDistribution

      public class TriangularDistribution
      extends AbstractRealDistribution

  Implementation of the triangular real distribution.
  Since:
    3.0
  Version:
    $Id: TriangularDistribution.java 1292741 2012-02-23 11:26:36Z erans $
  See Also:
    Triangular distribution (Wikipedia), Serialized Form

- - ### Field Summary

    - ### Fields inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

      `randomData, SOLVER_DEFAULT_ABSOLUTE_ACCURACY`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `TriangularDistribution(double a, double c, double b)` Create a triangular real distribution using the given lower limit, upper limit, and mode.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `cumulativeProbability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
    `double` | `density(double x)` Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`.
    `double` | `getMode()` Returns the mode `c` of this distribution.
    `double` | `getNumericalMean()` Use this method to get the numerical value of the mean of this distribution.
    `double` | `getNumericalVariance()` Use this method to get the numerical value of the variance of this distribution.
    `protected double` | `getSolverAbsoluteAccuracy()` Returns the solver absolute accuracy for inverse cumulative computation.
    `double` | `getSupportLowerBound()` Access the lower bound of the support.
    `double` | `getSupportUpperBound()` Access the upper bound of the support.
    `double` | `inverseCumulativeProbability(double p)` Computes the quantile function of this distribution.
    `boolean` | `isSupportConnected()` Use this method to get information about whether the support is connected, i.e.
    `boolean` | `isSupportLowerBoundInclusive()` Use this method to get information about whether the lower bound of the support is inclusive or not.
    `boolean` | `isSupportUpperBoundInclusive()` Use this method to get information about whether the upper bound of the support is inclusive or not.
    `double` | `probability(double x)` For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.

    - ### Methods inherited from class org.apache.commons.math3.distribution.AbstractRealDistribution

      `cumulativeProbability, reseedRandomGenerator, sample, sample`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### TriangularDistribution

          public TriangularDistribution(double a,
                                double c,
                                double b)
                                 throws NumberIsTooLargeException,
                                        NumberIsTooSmallException

      Create a triangular real distribution using the given lower limit, upper limit, and mode.
      Parameters:
        `a` - Lower limit of this distribution (inclusive).
        `b` - Upper limit of this distribution (inclusive).
        `c` - Mode of this distribution.
      Throws:
        `NumberIsTooLargeException` - if `a >= b` or if `c > b`
        `NumberIsTooSmallException` - if `c < a`

  - ### Method Detail

    - #### getMode

          public double getMode()

      Returns the mode `c` of this distribution.
      Returns:
        the mode `c` of this distribution

    - #### getSolverAbsoluteAccuracy

          protected double getSolverAbsoluteAccuracy()

      Returns the solver absolute accuracy for inverse cumulative computation. You can override this method in order to use a Brent solver with an absolute accuracy different from the default.

      For this distribution, the returned value is not really meaningful, since exact formulas are implemented for the computation of the `inverseCumulativeProbability(double)` (no solver is invoked).

      For lower limit `a` and upper limit `b`, the current implementation returns `max(ulp(a), ulp(b)`.

      Overrides:
        `getSolverAbsoluteAccuracy` in class `AbstractRealDistribution`
      Returns:
        the maximum absolute error in inverse cumulative probability estimates

    - #### probability

          public double probability(double x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution. For this distribution `P(X = x)` always evaluates to 0.
      Parameters:
        `x` - the point at which the PMF is evaluated
      Returns:
        0

    - #### density

          public double density(double x)

      Returns the probability density function (PDF) of this distribution evaluated at the specified point `x`. In general, the PDF is the derivative of the `CDF`. If the derivative does not exist at `x`, then an appropriate replacement should be returned, e.g. `Double.POSITIVE_INFINITY`, `Double.NaN`, or the limit inferior or limit superior of the difference quotient. For lower limit `a`, upper limit `b` and mode `c`, the PDF is given by
      - `2 * (x - a) / [(b - a) * (c - a)]` if `a <= x < c`,
      - `2 / (b - a)` if `x = c`,
      - `2 * (b - x) / [(b - a) * (b - c)]` if `c < x <= b`,
      - `0` otherwise.
      Parameters:
        `x` - the point at which the PDF is evaluated
      Returns:
        the value of the probability density function at point `x`

    - #### cumulativeProbability

          public double cumulativeProbability(double x)

      For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution. For lower limit `a`, upper limit `b` and mode `c`, the CDF is given by
      - `0` if `x < a`,
      - `(x - a)^2 / [(b - a) * (c - a)]` if `a <= x < c`,
      - `(c - a) / (b - a)` if `x = c`,
      - `1 - (b - x)^2 / [(b - a) * (b - c)]` if `c < x <= b`,
      - `1` if `x > b`.
      Parameters:
        `x` - the point at which the CDF is evaluated
      Returns:
        the probability that a random variable with this distribution takes a value less than or equal to `x`

    - #### getNumericalMean

          public double getNumericalMean()

      Use this method to get the numerical value of the mean of this distribution. For lower limit `a`, upper limit `b`, and mode `c`, the mean is `(a + b + c) / 3`.
      Returns:
        the mean or `Double.NaN` if it is not defined

    - #### getNumericalVariance

          public double getNumericalVariance()

      Use this method to get the numerical value of the variance of this distribution. For lower limit `a`, upper limit `b`, and mode `c`, the variance is `(a^2 + b^2 + c^2 - a * b - a * c - b * c) / 18`.
      Returns:
        the variance (possibly `Double.POSITIVE_INFINITY` as for certain cases in `TDistribution`) or `Double.NaN` if it is not defined

    - #### getSupportLowerBound

          public double getSupportLowerBound()

      Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

      `inf {x in R | P(X <= x) > 0}`.

      The lower bound of the support is equal to the lower limit parameter `a` of the distribution.
      Returns:
        lower bound of the support

    - #### getSupportUpperBound

          public double getSupportUpperBound()

      Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

      `inf {x in R | P(X <= x) = 1}`.

      The upper bound of the support is equal to the upper limit parameter `b` of the distribution.
      Returns:
        upper bound of the support

    - #### isSupportLowerBoundInclusive

          public boolean isSupportLowerBoundInclusive()

      Use this method to get information about whether the lower bound of the support is inclusive or not.
      Returns:
        whether the lower bound of the support is inclusive or not

    - #### isSupportUpperBoundInclusive

          public boolean isSupportUpperBoundInclusive()

      Use this method to get information about whether the upper bound of the support is inclusive or not.
      Returns:
        whether the upper bound of the support is inclusive or not

    - #### isSupportConnected

          public boolean isSupportConnected()

      Use this method to get information about whether the support is connected, i.e. whether all values between the lower and upper bound of the support are included in the support. The support of this distribution is connected.
      Returns:
        `true`

    - #### inverseCumulativeProbability

          public double inverseCumulativeProbability(double p)
                                              throws OutOfRangeException

      Description copied from class: `AbstractRealDistribution`
      Computes the quantile function of this distribution. For a random variable `X` distributed according to this distribution, the returned value is
      - `inf{x in R | P(X<=x) >= p}` for `0 < p <= 1`,
      - `inf{x in R | P(X<=x) > 0}` for `p = 0`.
      The default implementation returns
      - `RealDistribution.getSupportLowerBound()` for `p = 0`,
      - `RealDistribution.getSupportUpperBound()` for `p = 1`.
      Specified by:
        `inverseCumulativeProbability` in interface `RealDistribution`
      Overrides:
        `inverseCumulativeProbability` in class `AbstractRealDistribution`
      Parameters:
        `p` - the cumulative probability
      Returns:
        the smallest `p`-quantile of this distribution (largest 0-quantile for `p = 0`)
      Throws:
        `OutOfRangeException` - if `p < 0` or `p > 1`

Copyright © 2003-2012 The Apache Software Foundation. All Rights Reserved.